# Hypi Tink

This package provides the APIs needed to develop extenstions (Widgets or Actions) for Hypi's nocode platform.

# Basics

The platform supports two types of extensions:

1. Widgets
2. Actions

Widgets are any Flutter Stateful or Stateless widgets that you'd like to use in Hypi's editor.

Actions are any piece of code you'd like to use to provide custom behaviour for an app. An action can literally be made
to do anything that's possible in a standard Flutter app.

# Widget extension

Developing a Widget extension involves building the widget itself and providing Hypi Tink with a handler implementation
for this widget. A handler is a class which mixes in the `HypiTinkWidgetHandler` mixin AND has the `@TinkEditorHandler`
annotation.

`MyWidgetHandler` example is a simple if useless widget but demonstrates the minimum required code for developing a custom Hypi Tink widget extension.

Once you've finished developing your widget extension, provide the git repository URL in the editor and it will discover and load your widget from your repo (public or private).

# Action extension

An action extension is a class which mixes in the `TinkActionLike` mixin.

Extensions are automatically discovered and registered in the editor as long as they are annotated (for widget extensions) or mixes in `TinkActionLike`.
