import 'hypi_tink_api.dart';

/// Added to classes that are sub-types of [TinkWidgetHandler] to reigister them for processing behaviour when specific widgets are interacted with in the editor.
class TinkEditorHandler<T extends TinkWidgetHandler>
    implements Comparable<TinkEditorHandler<T>> {
  /// The set of [Widget]s that this handler can process.
  /// A handler with fewer widgets is considered more specific so if a more specific handler is found it is used over the less specific one
  final List<String> widgets;

  const TinkEditorHandler(this.widgets);

  @override
  int compareTo(TinkEditorHandler<T> other) {
    return widgets.length - other.widgets.length;
  }
}
